// **********************************************************************************
//
//  フィールド非表示プラグイン
//
//  履歴
//    2022.07.21   新規作成(松本)
//
//                                                   Copyright(C)2022 Caminova, Inc.
// **********************************************************************************
(function (PLUGIN_ID) {
    "use strict";
    var config = JSON.parse(kintone.plugin.app.getConfig(PLUGIN_ID).key); 
    console.log(config);
    //フィールドIDを取得
    const fields = Object.values(cybozu.data.page.FORM_DATA.schema.table.fieldList);
    console.log(fields);
    //フィールドコードをキーにフィールド情報を引くオブジェクト
    const fieldMap = fields.reduce((map, field) => ({ ...map, [field.var]: field }), {});
    console.log(fieldMap);
    // **********************************************************************************
    //   保存時の処理
    // **********************************************************************************
    kintone.events.on(['app.record.create.submit', 'app.record.edit.submit','app.record.index.edit.submit'], function (event) {
        if(Object.keys(config.fieldBtnCode).length == 0){
            return event;
        }
        var text;
        if(event.record[config.fieldBtnCode[0].split(',')[0]].value == undefined){
            text = "";
        }else{
            text = event.record[config.fieldBtnCode[0].split(',')[0]].value;
        }
        
        if(config.linktype){
            for(var x = 1; x < Object.keys(config.fieldBtnCode).length; x++){
                var linktext = config.linktext[x];
                if(linktext == undefined)linktext = "";
                console.log(config.fieldBtnCode[x].split(',')[0]);
                if(text == ""){
                    if(event.record[config.fieldBtnCode[x].split(',')[0]].value == undefined){
                        text = "";
                    }else{
                        text += event.record[config.fieldBtnCode[x].split(',')[0]].value;
                    }
                }else if(event.record[config.fieldBtnCode[x].split(',')[0]].value != undefined){
                    text += linktext + event.record[config.fieldBtnCode[x].split(',')[0]].value;
                }
            }
        }else{
            for(var x = 1; x < Object.keys(config.fieldBtnCode).length; x++){
                var linktext = config.linktext[x];
                if(linktext == undefined)linktext = "";
                console.log(config.fieldBtnCode[x].split(',')[0]);
                if(event.record[config.fieldBtnCode[x].split(',')[0]].value == undefined){
                    text += linktext + "";
                }else{
                    text += linktext + event.record[config.fieldBtnCode[x].split(',')[0]].value;
                }
            }
        }
        event.record[config.linkfield].value = text;
        return event;
    });
})(kintone.$PLUGIN_ID);